

/* Equivalencias entre arreglos y punteros */

int strlen(char *s){
	char *p = s;

	/*busco el 0 al final*/
	while(*p != '\0')
		p++;

	/*p esta apuntando al 0 final y s al inicio. la diferencia da el largo total*/
	return p-s;
}

int

/*string copy con arreglos*/
/*strcpy (destino, origen)*/
void strcpy(char *s, char *t){
	int i;
	i=0;

	while((s[i] = t[i]) != '\0')
		i++;
}

/*string copy con punteros */

void strcpy1(char *s, char *t){
	while((*s = *t) != '\0' ){
		s++;
		t++;
	}
}

void strcpy2(char *s, char *t){
	while((*s++ = *t++) != '\0')
		;
}

void strcpy3(char *s, char *t){
	while(*s++ = *t++)
		;
}


/*strcmp*/
/* compara s1 y s2. si s1 < s2 retorna <0, si s1 == s2 retorna 0, y si s1 > s2 retorna >0 */

int strcmp(char *s, char *t){
	int i;

	for(i = 0; s[i] == t[i]; i++)
		if(s[i] == '\0')
			return 0;
	return s[i] - t[i];
}

/* version punteros */ 
int strcmp2(char *s, char *t){
	for (; *s==*t; s++,t++) 
		if (*s == '\0')
			return 0;
	
	return *s-*t;
}



/* 
 * Esta funcion pide memoria dinamica para un nuevo string donde 
 * se copia el contenido del argumento */
char *strdup(char *s) { 
	char *p;
	p = (char *)malloc(Strlen(s)+1); 
	if(p == NULL) 
		return p;	/* No hay memoria disponible */ 
	Strcpy(p, s); 
	return p;
}



/*
 * Para probar:
 *
 * char s1[8] = "abcdefg";
 * char s2[8];
 *
 * strcpy(s2, s1);
 *
 * printf("s1: %s \n", s1);
 * printf("s2: %s \n", s2);
 *
 *
 * */



Program to calculate frequency of vowels in a string

#include <stdio.h>
void main()
{
	int a=0,e=0,i=0,o=0,u=0,sum=0;
	char c;
	printf("Entrar un string (Enter para terminar): \n");
	printf("STRING:-  ");
	while ((c=getchar())!='\n')
	{
		if (c=='a'||c=='A')
			a=a+1;
		if (c=='e'||c=='E')
			e=e+1;
		if (c=='i'||c=='I')
			i=i+1;
		if (c=='o'||c=='O')
			o=o+1;
		if (c=='u'||c=='U')
			u=u+1;
	}
	sum=a+e+i+o+u;
	printf("Frecuencia de 'a' es %d. \n",a);
	printf("Frecuencia de 'e' es %d. \n",e);
	printf("Frecuencia de 'i' es %d. \n",i);
	printf("Frecuencia de 'o' es %d. \n",o);
	printf("Frecuencia de 'u' es %d. \n",u);
	printf("Total de vocales %d.\n",sum);
}





#include <string.h>
#include <stdio.h>

void main()
{
	char frase[100], *sub_text;
	char *string = "Nos encanta programar en C";
	strcpy(frase, string);
	printf("Frase: %s\n", frase);
	strcat(frase," y en java.");
	printf("Frase concatenada: %s\n", frase);
	
	
	printf("Largo de frase: %d\n", (int)strlen(frase));
	
	if ((sub_text = strchr(frase, 'P') )!= NULL)
		printf("String empieza con \"P\" ->%s\n", sub_text);
	
	if (( sub_text = strchr(frase, 'p'))!= NULL)
		printf("String empieza con \"p\" ->%s\n", sub_text);
	
	if (( sub_text = strchr(sub_text,'e'))!= NULL)
		printf("String empieza con \"e\" ->%s\n", sub_text);
	
}

